//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon S. Lee (jl), Kee-Eung Kim (kek)
//  FILE: PCIdent.C
//  PROJ: COKO
//  DATE: 5/5/97
//
//  SYNOPSIS
//   Methods definitions for CIdent class.
//  
//////////////////////////////////////////////////////////////////////////////

#include "PCIdent.H"

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: CIdent
// Parameters:	(void)
//
// Parameterless Constructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CIdent::CIdent(void):
  _Parent(NULL),
  _Child(NULL),
  _Which(0)
{
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: CIdent
// Parameters:	(NonType*, int)
//
// Constructor with child and which.
//         								    
//////////////////////////////////////////////////////////////////////////////

CIdent::CIdent(NonType* child, int which)
{
  if (child) _Child = child->Copy_kTree(); 
  else 
	{ 
	  cout << "Error @ CIdent : CIdent" << endl;
	  cout << "Child is NULL error " << endl;
	  exit(1);
	}
  _Which = which;
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: CIdent
// Parameters:	(NonType*, int)
//
// Constructor with parent, child and which.
//
// parent is just a dummy input.
//
// This methods is exactly same as one above except that 
// this one have one more dummy input.
//         								    
//////////////////////////////////////////////////////////////////////////////

CIdent::CIdent(NonType* parent, NonType* child, int which)
{
  if (child) _Child = child->Copy_kTree(); 
  else 
	{ 
	  cout << "Error @ CIdent : CIdent" << endl;
	  cout << "Child is NULL error " << endl;
	  exit(1);
	}
  _Which = which;
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: ~CIdent
// Parameters: (void)
//
// Destructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

CIdent::~CIdent(void)
{
  if (_Child) { delete _Child; _Child = NULL; }
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: SetChild
// Parameters: (NonType*)
//
// Set _Child to input.
//         								    
//////////////////////////////////////////////////////////////////////////////

void CIdent::SetChild(NonType* child)
{
  _Child = child;
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: Child
// Parameters: (void)
//
// Returns a copy of _Child.
//         								    
//////////////////////////////////////////////////////////////////////////////

NonType *CIdent::Child(void)
{
  if (_Child)
	return _Child->Copy_kTree();
  else
	return NULL;
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: Child_Look_Up
// Parameters: (void)	
//
// Returns a pointer to _Child.
//         								    
//////////////////////////////////////////////////////////////////////////////

NonType *CIdent::Child_Look_Up(void)
{
  return _Child;
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: Which
// Parameters: (void)
//
// Returns _Which.
//         								    
//////////////////////////////////////////////////////////////////////////////

int CIdent::Which(void)
{
  return _Which;
}



