//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Joon Suk  Lee (jl)                                             
//  FILE: PCSQPrintStmt.H
//  PROJ: COKO
//  DATE: 9/96                                                   
//
// SYNOPSIS
// 
//  This class is a derived class from CStmt. It is used for coko language 
//  debugging purposes.
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef _PCSQPRINTSTMT_H_
#define _PCSQPRINTSTMT_H_

#include <assert.h>
#include "PCStmt.H"
#include "PCRule.H"
#include "PCRuleBlock.H"
#include "KOObject.H"
#include "KOBool.H"
#include "PCState.H"
#include "KOOVar.H"



class CSQPrintStmt : public CStmt {
protected:
  char * _iname;         
  // The identifier name 
  
  int _which_print; 
  // what type of print command is it?

public:
  CSQPrintStmt(int, char *);
  // Constructor

  ~CSQPrintStmt();
  // Destructor

  CState *Exec(CState *);
  // What to do when executed


  //DJA SUMMER 2001:
  //Added rep_string, representation, is_leaf and ExecDebug methods

  char* rep_string ();
   //returns the string representation of only the current 
  //node of the COKO tree

  char* representation (int);
  //returns string representation of COKO tree

  char* representationWDI(int, DDebugController *);
  //returns string representation of COKO tree
  //but also update the debugger with the location (row and
  //column) of each breakable statement's substring

  CState *ExecDebug(CState *, DDebugController *);
  //what to do when executed in debug mode
  
  int is_leaf();
  //returns whether current statement is a leaf in the COKO tree

};

#endif
