//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Marina Zlatkina
//  FILE: AndProperty.C
//  PROJ: COKO
//  DATE: 8/2001                                                        
//
// SYNOPSIS
//  Class that represents a conjunction of two property requirements.
//  
//////////////////////////////////////////////////////////////////////////////

#include "AndProperty.H"
#include "NonTypeArgs.H"
#include <iostream>
using namespace std;

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: AndProperty
// Parameters:	(Property *, Property *)
//
// Constructor.
//         								    
//////////////////////////////////////////////////////////////////////////////
AndProperty::AndProperty(Property *prop1, Property *prop2):
  first(prop1), second(prop2) {}


//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: isTrue
// Parameters:	(CState *, NonTypeArgs *)
//
// Determines if both of the properties are true.
//         								    
//////////////////////////////////////////////////////////////////////////////
NonTypeArgs *AndProperty::isTrue(CState *s, NonTypeArgs *a){

  // if the first Property is not true, there is no need to evaluate
  // the second - just return false. Otherwise, return whatever the
  // isTrue method of the second Property returns.
  
  NonTypeArgs *args = first->isTrue(s,a);

  if (!args->GetSuccess())
    return args;
  else{
    NonTypeArgs *args2 = second->isTrue(s,a);  
    if ( args2->GetSuccess()){
      NonTypeList *list = args->theList();
      list->initIterator();
      NonTypeList *l = args2->theList();
      NonType *current;

      // save the total number of arguments
      int total = args->numArgs()+args2->numArgs();

      // add the matched variables from the first list, to the second
      while(current = list->getValue())
	l->insert(current->Copy_kTree());
      
      delete args;
      delete list;
      NonTypeArgs *return_args= new NonTypeArgs( l,total);
      return_args->SetSuccess(true);
      
      return return_args;
    }
    else{
      delete args;
      return args2;
    }
  }
}
