//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Marina Zlatkina
//  FILE: MatchProperty.C
//  PROJ: COKO
//  DATE: 8/2001                                                        
//
// SYNOPSIS
//  A class that matches the variables in the arguments to the property
//  found on the RHS of a rule to the values of those arguments provided
//  at runtime.
//  
//////////////////////////////////////////////////////////////////////////////
#include "MatchProperty.H"
#include <PCState.H>

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: MatchProperty
// Parameters:	(NonTypeArgs *)
//
// Constructor.
//         								    
//////////////////////////////////////////////////////////////////////////////
MatchProperty::MatchProperty(NonTypeArgs *nt){
  pattern = nt;
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: isTrue
// Parameters:	(CState *, NonTypeArgs *)
//
// Determines if the values of the arguments provided can be matched with
// their patterns as specified in the RHS of a rule.
//         								    
//////////////////////////////////////////////////////////////////////////////
NonTypeArgs * MatchProperty::isTrue(CState *s, NonTypeArgs *a){
  
  // create a blank variable stack for the environment
  s->SetIEnv(new CIEnvStack());
  
  // return the success value of calling match on the patter NonTypeArgs.

  NonTypeArgs *ret_val = new NonTypeArgs(new NonTypeList(),0);

  if (pattern->match(s,a)->ISuccess())
    ret_val->SetSuccess(true);
  
  return ret_val;
}
