//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Marina Zlatkina
//  FILE: OrProperty.C
//  PROJ: COKO
//  DATE: 8/2001                                                        
//
// SYNOPSIS
//  Class that represents a disjunction of two property requirements.
//  
//////////////////////////////////////////////////////////////////////////////
#include "OrProperty.H"
#include "PCIEnvStack.H"
#include "NonTypeArgs.H"
//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: AndProperty
// Parameters:	(Property *, Property *)
//
// Constructor.
//         								    
//////////////////////////////////////////////////////////////////////////////
OrProperty::OrProperty(Property *prop1, Property *prop2) : 
  first(prop1), second(prop2) {}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: isTrue
// Parameters:	(CState *, NonTypeArgs *)
//
// Determines if at least one of the properties is true.
//         								    
//////////////////////////////////////////////////////////////////////////////
NonTypeArgs *OrProperty::isTrue(CState *s, NonTypeArgs *a){

  NonTypeArgs *return_val = first->isTrue(s,a);

  // if the first Property is not true
  if (!return_val->GetSuccess())
    return_val = second->isTrue(s,a);
  
  return return_val;
}
