//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Kee-Eung Kim (kek), Joon S. Lee (jl)
//  FILE: PCMatchEachStmt.H
//  PROJ: COKO
//  DATE: 5/5/97
//
// SYNOPSIS
//  Class definitions for CMatchEachStmt.
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef _PCMATCHEACHSTMT_H_
#define _PCMATCHEACHSTMT_H_

#include "PCStmt.H"
#include "PCChildPattern.H"

class CMulMatchStmt;

//////////////////////////////////////////////////////////////////////////////
//
//  CLASS: CMatchEachStmt
//
// SYNOPSIS
//  This class is a derived class from CStmt. It is used for Match each child
//  statements in COKO rule block.
//
//////////////////////////////////////////////////////////////////////////////

class CMatchEachStmt : public CStmt {
protected:
  CChildPattern *_first;                     // Child pattern specified in 
                                             // rule block.
  CStmt *_second;                            // Match each child stmt body.
    
public:
  CMatchEachStmt(CChildPattern *, CStmt *);  // Constructor.
  ~CMatchEachStmt(void);                     // Destructor.
  CState *Exec(CState *);                    // What to do when executed.

};

#endif
