//////////////////////////////////////////////////////////////////
//
//  NAME: Joon S. Lee (jl), Kee-Eung Kim (kek)
//  
//  FILE: PCRule.H
//  PROJ: COKO
//  DATE: 6/96
// 
//  SYNOPSIS
//  This class is for Match Statements
//
/////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////
//
//  - Modifications -
//
//  kek - 8/27/96 - match and build are made virtual for the use with 
//    CChildPattern.
//  kek - 8/28/96 - virtual Destructor added.
//
////////////////////////////////////////////////////////////////////////

#ifndef _PCPATTERN_H_
#define _PCPATTERN_H_

#include "PCStmt.H"
#include "PCState.H"
#include "KONameUnion.H"
#include "KGlobals.H"
#include "KONonType.H"

class CPattern
{
 public:
  CPattern (NonType *);
  // Constructor for pattern representation.

  virtual ~CPattern();
  // Destructor

  virtual CState* match(CState*);
  // This method is for rule matching only.
  //  Duplicated variable entry is allowed here.

  virtual CState* matchSTM(CState*);
  //  This match method is used for matching statement.
  //  No duplicated variable entry is allowed.

  CState* DepListCheck(char*, CState*);

  CState* undoDEP(char*, CState*);

  virtual CState* build(CState*);

  virtual CState* buildFromHere(CState*, CIEnvStackDataType*);

  virtual CState* buildCurrent(CState*); 

  void updateNTVarNum(int);
  //ADDED by DJA WINTER 2002


  //DJA SUMMER 2001:
  //Added rep_string, and representation methods

  char* rep_string ();
  //returns the string representation of only the current 
  //node of the COKO tree

  char* representation();

  NonType* getNT() { return rrclass; }
  // Returns stored NonType Pattern

  virtual void SetStackPointer(CIEnvStackDataType* stackPt);

 protected:

  CIEnvStackDataType* _savedStackTop;
  // Save the position of stack top
  // this is for current pattern only. 

  NonType* rrclass;

};

#endif
