
/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Mitch Cherniack (mfc)
//        Xiaoyu Wang (wangxy)
//  FILE: KOTLArrow.C 
//  PROJ: COKO, KOLA
//  DATE: 9/00		                                                    
//
//////////////////////////////////////////////////////////////////////////////

#include "KOTLArrow.H"
extern "C" { int atio(const char *s); }
  
//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  TLArrow
// Parameters: (TagExp* te, Tag* tg)
//
// Constructor.
//
// needs refine later...
//
/////////////////////////////////////////////////////////////////////////////

TLArrow::TLArrow(TagExp* te, Tag* tg):TagExp(TAGEXP_LARROW, "<-" )
{
  one = te;
  two = tg;
  variableNum = 0;
}

//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  TLArrow
// Parameters:(TLArrow& other)
//
// Copy Constructor
//
/////////////////////////////////////////////////////////////////////////////

TLArrow::TLArrow(const TLArrow& other):TagExp((TagExp &)other)
{
  one = other.One()->Copy();
  two = other.Two()->Copy();
  variableNum = other.getVariableNum();
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: ~TLArrow
// Parameters: ()
//
// Destructor
//
/////////////////////////////////////////////////////////////////////////////

TLArrow::~TLArrow()
{
  delete one;
  delete two;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: Copy
// Parameters: ()
//
// return the copy of this tagexp
//
/////////////////////////////////////////////////////////////////////////////

TagExp* TLArrow::Copy() const
{
  TLArrow* temp = new TLArrow (*this);
  temp->setVariableNum(variableNum);
  return temp;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: deepeq
// Parameters: (NonType *)
//
// does nothing
//
/////////////////////////////////////////////////////////////////////////////

int TLArrow::deepeq(NonType* other)
{
  return T;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: Myname
// Parameters: ()
//
// does nothing
//
////////////////////////////////////////////////////////////////////////////

NameUnion* TLArrow::Myname()
{
  return NULL;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name:  nextChild
// Parameters: ()
//
// Return "currChild++"th child.
// When currChild is equal to the number of children
// (when currChild is the last child), it returns NULL.
//
/////////////////////////////////////////////////////////////////////////////

NonType* TLArrow::nextChild()
{
  if(currChild == 0){
    currChild++;
    return one;
  } else { 
    if(currChild == 1){
      currChild++;
      return two;
    } else return NULL;
  }
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: representation
// Parameters: ()
//
/////////////////////////////////////////////////////////////////////////////

char * TLArrow::representation()
{
  char *pr1 = one->representation();
  char *pr2 = two->representation();
  
  char *res = new char[strlen(pr1)+strlen(pr2)+strlen("() <- ")+1];
  sprintf(res, "(%s) <- %s", pr1, pr2);
  delete [] pr1;
  delete [] pr2;
  return res;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: transform
// Parameters: (CState*)
//
// Return corresponding NonType object.
//
// Now it does nothing just return itself 
//
////////////////////////////////////////////////////////////////////////////

NonType* TLArrow::transform(CState* s)
{
  return this;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: compares
// Parameters: (NonType*, CState*)
//
// compare two trees
//
////////////////////////////////////////////////////////////////////////////

int TLArrow::compares(NonType* nt, CState* a)
{
    return T;
}

//////////////////////////////////////////////////////////////////////////
//
// Function Name: compareSTM
// Parameter: (NonType*, CState*)
//
// Check for match between two NonType tree...
//
//////////////////////////////////////////////////////////////////////////

int TLArrow::compareSTM(NonType* nt, CState* a)
{
    return T;
}

///////////////////////////////////////////////////////////////////////////
//
// Function Name: replaceChild
// Parameters: (NonType*, int)
//
// Replace a child of a given tree..
//
///////////////////////////////////////////////////////////////////////////

void TLArrow::replaceChild(NonType* child, int which_child)
{
  if(which_child == 1)
    setOne(child);
  else if(which_child == 2)
    setTwo(child);
}


///////////////////////////////////////////////////////////////////////////
//
// Function Name: prolog
// Parameters:()
//
// Does nothing, return NULL
//
//////////////////////////////////////////////////////////////////////////

char* TLArrow::prolog()
{
    return NULL;
}

#ifdef _PROLOG_
///////////////////////////////////////////////////////////////////////////
//
// Function Name: sp_prolog
// Parameters:()
//
// Does nothing, return NULL
//
///////////////////////////////////////////////////////////////////////////

SP_term_ref TLArrow::sp_prolog()
{
    return NULL;
}
#endif //_PROLOG_

