/* -*-Mode:c++-*- */

//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Mitch Cherniack (mfc)
//        Xiaoyu Wang (wangxy)
//  FILE: KOTSt.C 
//  PROJ: COKO, KOLA
//  DATE: 9/00		                                                    
//
//////////////////////////////////////////////////////////////////////////////

#include "KOTSt.H"
extern "C" { int atio(const char *s); }
  
//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  TSt
// Parameters: (TagExp* te, Predicate* p)
//
// Constructor.
//
// needs refine later...
//
/////////////////////////////////////////////////////////////////////////////

TSt::TSt(TagExp* te, Predicate* p):TagExp(TAGEXP_ST, "st" )
{
    one = te;
    two = p;
    variableNum = 0;
}

//////////////////////////////////////////////////////////////////////////////
//
// Function Name:  TSt
// Parameters:(TSt& other)
//
// Copy Constructor
//
/////////////////////////////////////////////////////////////////////////////

TSt::TSt(const TSt& other):TagExp((TagExp &)other)
{
    one = other.One()->Copy();
    two = other.Two()->Copy();
    variableNum = other.getVariableNum();
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: ~TSt
// Parameters: ()
//
// Destructor
//
/////////////////////////////////////////////////////////////////////////////

TSt::~TSt()
{
    delete one;
    delete two;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: Copy
// Parameters: ()
//
// return the copy of this tagexp
//
/////////////////////////////////////////////////////////////////////////////

TagExp* TSt::Copy() const
{
  TSt* temp = new TSt (*this);
  temp->setVariableNum(variableNum);
  return temp;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: deepeq
// Parameters: (NonType *)
//
// does nothing
//
/////////////////////////////////////////////////////////////////////////////

int TSt::deepeq(NonType* other)
{
  return T;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: Myname
// Parameters: ()
//
// does nothing
//
////////////////////////////////////////////////////////////////////////////

NameUnion* TSt::Myname()
{
  return NULL;
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name:  nextChild
// Parameters: ()
//
// Return "currChild++"th child.
// When currChild is equal to the number of children
// (when currChild is the last child), it returns NULL.
//
/////////////////////////////////////////////////////////////////////////////

NonType* TSt::nextChild()
{
  if(currChild == 0)
    {
      currChild++;
      return one;
    }
  else { 
    if(currChild == 1){
      currChild++;
      return two;
    } 
    else return NULL;
  }
}

/////////////////////////////////////////////////////////////////////////////
//
// Function Name: representation
// Parameters: ()
//
/////////////////////////////////////////////////////////////////////////////

char * TSt::representation()
{
  char *pr1 = one->representation();
  char *pr2 = two->representation();
  
  char *res = new char[strlen(pr1)+strlen(pr2)+strlen("() ST ()")+1];
  sprintf(res, "(%s) ST (%s)", pr1, pr2);
  delete [] pr1;
  delete [] pr2;
  return res;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: transform
// Parameters: (CState*)
//
// Return corresponding NonType object.
//
// Now it does nothing just return itself 
//
////////////////////////////////////////////////////////////////////////////

NonType* TSt::transform(CState* s)
{
  return this;
}

////////////////////////////////////////////////////////////////////////////
//
// Function Name: compares
// Parameters: (NonType*, CState*)
//
// compare two trees
//
////////////////////////////////////////////////////////////////////////////

int TSt::compares(NonType* nt, CState* a)
{
  return T;
}

//////////////////////////////////////////////////////////////////////////
//
// Function Name: compareSTM
// Parameter: (NonType*, CState*)
//
// Check for match between two NonType tree...
//
// Does nothing now, just return T, 
//
//////////////////////////////////////////////////////////////////////////

int TSt::compareSTM(NonType* nt, CState* a)
{
  return T;
}

///////////////////////////////////////////////////////////////////////////
//
// Function Name: replaceChild
// Parameters: (NonType*, int)
//
// Replace a child of a given tree..
//
///////////////////////////////////////////////////////////////////////////

void TSt::replaceChild(NonType* child, int which_child)
{
    if(which_child == 1)
      setOne(child);
    else if(which_child == 2)
      setTwo(child);
    
}


///////////////////////////////////////////////////////////////////////////
//
// Function Name: prolog
// Parameters:()
//
// Does nothing, return NULL
//
//////////////////////////////////////////////////////////////////////////

char* TSt::prolog()
{
    return NULL;
}

#ifdef _PROLOG_
///////////////////////////////////////////////////////////////////////////
//
// Function Name: sp_prolog
// Parameters:()
//
// Does nothing, return NULL
//
///////////////////////////////////////////////////////////////////////////

SP_term_ref TSt::sp_prolog()
{
  return NULL;
}
#endif //_PROLOG_

