/* output from Ox version G1.04 */
/*
 * Copyright 1995, Brown University, Providence, RI
 *
 * Permission to use and modify this software and its documentation for
 * any purpose other than its incorporation into a commercial product is
 * hereby granted without fee.  Permission to copy and distribute this
 * software and its documentation only for non-commercial use is also
 * granted without fee, provided, however, that the above copyright notice
 * appear in all copies, that both that copyright notice and this permission
 * notice appear in supporting documentation, that the name of Brown
 * University not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission,
 * and that the person doing the distribution notify Brown University of
 * such distributions outside of his or her organization. Brown University
 * makes no representations about the suitability of this software for
 * any purpose.  It is provided "as is" without express or implied warranty.
 * Brown University requests notification of any modifications to this
 * software or its documentation.
 *
 * Send the following redistribution information:
 *
 *	Name:
 *	Organization:
 *	Address (postal and/or electronic):
 *
 * To:
 *	Software Librarian
 *	Computer Science Department, Box 1910
 *	Brown University
 *	Providence, RI 02912
 *
 *		or
 *
 *	brusd@cs.brown.edu
 *
 * We will acknowledge all electronic notifications.

 \'[A-Za-z0-9]\'                                          { return CHARCON; @{ @CHARCON.string@ = lexeme(); @}}

//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Mitch Cherniack (mfc@cs.brown.edu)
//  FILE: QL.l 
//  PROJ: The "Karbonator"
//  DATE: 7/98		                                                    
//
//  QLite -> KOLA translator.  Lexical scanning file.
//
//////////////////////////////////////////////////////////////////////////////
*/

%{

#include "oxout.tab.h"
#include "KGlobals.H"
#include "KONonType.H"
#include <string.h>
#include <stdio.h>

int lineno3 = 1;
extern "C" {int atoi (const char *s);}

char *lexeme ()
{
  char *res = new char [yyleng + 1];
  sprintf (res, "%s", yytext);
  return res;
}
			       
%}


%{


struct yyyT1 {int val;}; 
typedef struct yyyT1 *yyyP1; 


struct yyyT2 {char *string;}; 
typedef struct yyyT2 *yyyP2; 


struct yyyT3 {char *string;}; 
typedef struct yyyT3 *yyyP3; 


struct yyyT4 {char *string;}; 
typedef struct yyyT4 *yyyP4; 


struct yyyT5 {char *string;}; 
typedef struct yyyT5 *yyyP5; 


struct yyyT6 {NonType *res;}; 
typedef struct yyyT6 *yyyP6; 


struct yyyT7 {Function *func; Predicate *pred; Environment *ienv;}; 
typedef struct yyyT7 *yyyP7; 


struct yyyT8 {Function *func;  Environment *ienv; Environment *oenv;}; 
typedef struct yyyT8 *yyyP8; 


struct yyyT9 {Function *func;  Environment *ienv;}; 
typedef struct yyyT9 *yyyP9; 


struct yyyT10 {Predicate *pred;  Environment *ienv;}; 
typedef struct yyyT10 *yyyP10; 


struct yyyT11 {Function *func;}; 
typedef struct yyyT11 *yyyP11; 


struct yyyT12 {Predicate *pred;}; 
typedef struct yyyT12 *yyyP12; 


struct yyyT13 {int val;}; 
typedef struct yyyT13 *yyyP13; 
                                                      /*custom*/  
typedef unsigned char yyyWAT; 
typedef unsigned char yyyRCT; 
typedef unsigned short yyyPNT; 
typedef unsigned char yyyWST; 

#include <limits.h>
#define yyyR UCHAR_MAX  

 /* funny type; as wide as the widest of yyyWAT,yyyWST,yyyRCT  */ 
typedef unsigned short yyyFT;

                                                      /*stock*/  




struct yyyGenNode {void *parent;  
                   struct yyyGenNode **cL; /* child list */ 
                   yyyRCT *refCountList; 
                   yyyPNT prodNum;                      
                   yyyWST whichSym; /* which child of parent? */ 
                  }; 

typedef struct yyyGenNode yyyGNT; 



struct yyyTB {int isEmpty; 
              int typeNum; 
              int nAttrbs; 
              char *snBufPtr; 
              yyyWAT *startP,*stopP; 
             };  




extern struct yyyTB yyyTermBuffer; 
extern yyyWAT yyyLRCIL[]; 
extern void yyyGenLeaf(int nAttrbs,int typeNum,
                       yyyWAT *startP,yyyWAT *stopP
                      ); 


%}
%%
[ \t]+						                             {}
[\n\f]                                                   { lineno3++; }
[-][-][^\n]+                                             { {yyyGenLeaf(0,0,yyyLRCIL+0,yyyLRCIL+0);return COMMENT;} }

[+-]?[0-9]+                                              { {yyyGenLeaf(1,1,yyyLRCIL+0,yyyLRCIL+1); (((yyyP1)(yyyTermBuffer.snBufPtr))->val) = atoi (yytext); return INTCON;} }
\"[^\"]*[\"]                                             { {yyyGenLeaf(1,2,yyyLRCIL+1,yyyLRCIL+2); (((yyyP2)(yyyTermBuffer.snBufPtr))->string) = lexeme(); return STRINGCON;} }
\`[^\']*[\']                                             { {yyyGenLeaf(1,2,yyyLRCIL+1,yyyLRCIL+2); (((yyyP2)(yyyTermBuffer.snBufPtr))->string) = lexeme(); return STRINGCON;} }
[+-]?(([0-9]+)|([0-9]*\.[0-9]+)([eE][-+]?[0-9]+)?)   	 { {yyyGenLeaf(1,3,yyyLRCIL+2,yyyLRCIL+3); (((yyyP3)(yyyTermBuffer.snBufPtr))->string) = lexeme(); return FLOATCON;} }
[Tt][Rr][Uu][Ee]					                     { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return TRUEV;} }  
[Ff][Aa][Ll][Ss][Ee]					                 { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return FALSEV;} }  
[Nn][Uu][Ll][Ll]					                     { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return NIL;} }  
[Nn][Ii][Ll]  					                         { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return NIL;} }  

"{"                                                      { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return ('{');} }  
"}"                                                      { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return ('}');} }     
"("                                                      { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return ('(');} }  
")"                                                      { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (')');} }  
","                                                      { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (',');} }  
":"                                                      { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (':');} }  
 
"+"                                                      { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return ('+');} }  
"-"                                                      { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return ('-');} }  
"*"                                                      { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return ('*');} }  
"/"                                                      { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return ('/');} }
"."                                                      { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (DOT);} }  
".."                                                     { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (DOT);} }  
"->"                                                     { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (DOT);} }  
"="                                                      { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return ('=');} }  
"<"                                                      { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return ('<');} }  
">"                                                      { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return ('>');} }  
"<="                                                     { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return LE;} } 
">="                                                     { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return GE;} } 
"!="                                                     { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return NE;} }

[Nn][Oo][Tt]  	      	   	     	       	    	     { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (NOT);} }  
[Aa][Nn][Dd]  	   	      	   	     	       	         { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (AND);} }  
[Oo][Rr]  	       	   	   	     	       	             { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (OR);} }  
[Ll][Ii][Kk][Ee]   	      	   	     	       	         { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (LIKE);} }  

[Ee][Ll][Ee][Mm][Ee][Nn][Tt]				             { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (ELT);} }  
[Ff][Ll][Aa][Tt][Tt][Ee][Nn]				             { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (FLATTEN);} }  
[Uu][Nn][Ii][Oo][Nn]                                     { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (UNION);} }  
[Ii][Nn][Tt][Ee][Rr][Ss][Ee][Cc][Tt]                     { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (INTERSECT);} }  
[Ee][Xx][Cc][Ee][Pp][Tt]                                 { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (EXCEPT);} }  
[Ss][Ee][Tt]                                             { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (SET);} }  
[Ee][Xx][Ii][Ss][Tt][Ss]  	       	       	     	     { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (EXISTS);} }  
[Ff][Oo][Rr][ \t]+[Aa][Ll][Ll]      	      	   	     { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (FORALL);} }  
[Ii][Nn]                                                 { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (INP);} }  
[Ss][Ee][Ll][Ee][Cc][Tt]                                 { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (SELECT);} }  
[Dd][Ii][Ss][Tt][Ii][Nn][Cc][Tt]                         { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (DISTINCT);} }  
[Ff][Rr][Oo][Mm]                                         { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (FROM);} }  
[Ww][Hh][Ee][Rr][Ee]                                     { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (WHERE);} }
[Gg][Rr][Oo][Uu][Pp]                                     { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (GROUP);} }  
[Oo][Rr][Dd][Ee][Rr]                                     { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (ORDER);} }
[Ss][Tt][Rr][Uu][Cc][Tt]  	       	       	     	     { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (STRUCT);} }  
[Aa][Ss][Cc]                                             { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (ASC);} }
[Dd][Ee][Ss][Cc]                                         { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (DESC);} }

[Mm][Oo][Dd]					                         { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (MOD);} }  
[Aa][Bb][Ss]					                         { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (ABS);} }
[Cc][Oo][Uu][Nn][Tt]                                     { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (COUNT);} }  
[Ss][Uu][Mm]                                             { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (SUM);} }  
[Mm][Ii][Nn]                                             { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (MIN);} }  
[Mm][Aa][Xx]                                             { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (MAX);} }  
[Aa][Vv][Gg]                                             { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (AVG);} }

[Ii][Ss]                                                 { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (IS);} }
[Bb][Yy]                                                 { {yyyGenLeaf(0,0,yyyLRCIL+3,yyyLRCIL+3);return (BY);} }
[:]?[a-zA-Z][a-z_\'A-Z0-9]*               		         { {yyyGenLeaf(1,5,yyyLRCIL+3,yyyLRCIL+4); (((yyyP5)(yyyTermBuffer.snBufPtr))->string) = lexeme(); return (IDENT);} }
.                    					                 { {yyyGenLeaf(0,0,yyyLRCIL+4,yyyLRCIL+4);return (ERROR);} }
%%



int yywrap ()  {return 1;}


