%{

#include "oxout.tab.h"
#include "KGlobals.H"
#include "KONonType.H"
#include <string.h>
#include <stdio.h>

int lineno3 = 1;
extern "C" { int atoi(const char *s); }

char  *lexeme()
{
  char * res;

  if(yytext[0] == '$') { res = new char[yyleng]; 
                         strcpy(res, yytext+1); }
   else { if(yytext[0] == '"'){ res = new char[yyleng-1];
                             strncpy(res, yytext+1, yyleng-2); 
                             res[yyleng-2] ='\0'; }
          else { res = new char[yyleng+1];
                 strcpy(res, yytext); }
  }
	
  return res;	

}

%}

%%

"<"  				{  return  LT; 		}  

">"  				{  return  GT;		}

"/>" 				{  return  SLASHGT;	} 

"</" 				{  return  LTSLASH;	}

","				{  return  COMMA;	}

"="				{  return  EQ;		}

"<>"				{  return  NEQ;		}

"{"				{  return  LBRACE;	}

"}"				{  return  RBRACE;	}

"*"				{  return STAR;		}

"+"				{  return  PLUS;        }

"."				{   return DOT;         }

"|"                             {   return  BAR;        }

[iI][nN]			{  return  INN;		}

$[a-zA-Z][a-zA-Z0-9_]*		{    
                                   return VAR;
				   @{  @VAR.str@ = lexeme(); @} 
				}

[eE][lL][eE][mM][eE][nN][tT][_][aA][sS]	{  return  ELEMENTAS;	}

[cC][oO][nN][tT][eE][nN][tT][_][aA][sS]	{  return  CONTENTAS;	}

[wW][hH][eE][rR][eE]		{  return  WHERE;		}

[cC][oO][nN][sS][tT][rR][uU][cC][tT]	{  return  CONSTRUCT;	}

[ \n\t\f]*        			;   

\"[^\"\n]*\"			{   
                                    return  STRING;
				  @{ @STRING.str@ = lexeme();  @}
				}

([a-zA-Z][a-zA-Z0-9_]*)		{   return  ID;
				  @{ @ID.str@ = lexeme(); @}
                                }

[.]*				{  fprintf(stderr,"illegal character\n"); 
				   exit(-1); 
               			} 

%%

int yywrap() { return 1; }












