/* -*Mode:c++-*- */

/////////////////////////////////////////////////////////////////////////
//
// Name: Xiaoyu Wang(wangxy@cs.brandeis.edu)
// File: QLAuxCode.cc
// Proj: XMLQL->KOLA Translator
// Date: 10/4/00
//
////////////////////////////////////////////////////////////////////////


#include "QLAuxCode.H"


Function *CopyFunc(Function *f)
{	
  if(f == NULL)
	return NULL;
  else
	return f->Copy();
	
}	

Predicate *CopyPred(Predicate *p)
{
  if(p == NULL)
	return NULL;
  else
	return p->Copy();
}

Tag *CopyTag(Tag *t)
{
  if (t == NULL)
	return NULL;
  else
	return t->Copy();
}

TagExp *CopyTagExp(TagExp *t)
{
  if(t == NULL)
	return NULL;
  else 
	return t->Copy();
}	


Function  *QFunc(Function *f1, Predicate *p1, Function *f2)	
{

  if(f1 == NULL || p1 == NULL || f2 == NULL){
    return NULL;
  }
  else{

    Function* sin = new FSingleton();
    
    Function* com1 = new FCompose(f1->Copy(), sin); 
    /* unnest... o singleton */

    Function* ite = new FIterate(p1->Copy(), f2->Copy());
    Function* com2 = new FCompose(ite, com1);
    /* iterate(p, f) o ... */

    Function* fla = new FFlatten();
    Function* com3 = new FCompose(fla, com2);
    /* flat o (...) */

    return com3;
  }
}


Function * QFunc(Function *f1, Function *f2)
  /* f1 inlist.trans, f2 cons.trans */
{	
  if( f1 == NULL || f2 == NULL ){
    return NULL;
  }
  else{
    Function* sin = new FSingleton();
    
    Function* com1 = new FCompose(f1->Copy(), sin );
    /* unnest ... o singleton */
    
    koBool    *tru = new BPrimitive(T);
    Predicate *pre  = new PConst(tru);
    /* K (true) */

    Function* ite = new FIterate(pre, f2->Copy());
    
    Function* com2 = new FCompose(ite, com1);
    /* iterate (K(true), ...) o (unnest.. o singleton )*/
       
    Function* fla = new FFlatten();
    
    Function* com3 = new FCompose(fla, com2);
    
    return com3;
  }
}


Function *InListTransFunc(Function *f)
{
  if( f == NULL )
    return NULL; 
  else 
    {
      TElem *ele1 = new TElem(new OStr("env"));
      TElem *ele2 = new TElem(new OStr("env"));
      TElem *ele3 = new TElem(new OStr("env"));
      
      Function *fel = new FEle(ele1);
      Function *app = new FApp();
      
      Function *ext1 = new FExtract(new TTilde(ele2));
      Function *ext2 = new FExtract(new TTilde(ele3));
      /* extract(~ (% env)) */
      
      Function *tim = new FTimes(ext1, ext2);
      /* extract X extract */
      
      Function *com1 = new FCompose(app, tim);
      /* app o ( ... X  ...) */
      
      Function *com2 = new FCompose(fel, com1);
      /* ele o app o ( ...X...) */
      
      Function *unn = new FUnnest(com2, f->Copy());
      /* unnest(com2, f ) */
      
      return unn;
    }
}


Function *InListTransFunc(Function *f1, Function *f2)
{
  if( f1 == NULL || f2 == NULL )
    return NULL;
  else
    {
      TElem *elm1 = new TElem(new OStr("env"));
      TElem *elm2 = new TElem(new OStr("env"));
      TElem *elm3 = new TElem(new OStr("env"));
  
      Function *ele = new FEle(elm1);
      Function *app = new FApp();
      
      Function *ext1 = new FExtract(new TTilde(elm2));
      Function *ext2 = new FExtract(new TTilde(elm3));
      /* extract (~ (% env)) */

      Function *tim = new FTimes(ext1, ext2);
      /* extract X extract */
      
      Function *com1 = new FCompose(app, tim);
      /* app o (... X ...) */

      Function *com2 = new FCompose(ele, com1);
      /* ele o app o (... X ...) */
      
      Function *unn = new FUnnest(com2, f1->Copy());
      /* unnest(com2, f) */

      Function *com3 = new FCompose(unn, f2->Copy());
      /* unnest(...) o unnest o (...) o unnest (...) */

      return com3;
    }
}


Function *InTransFunc(char *type, TagExp *t1, TagExp *t2, char *s)
{	
  if(type == NULL || t1 == NULL || t2 == NULL || s == NULL)
    return NULL;
  else
    {      
      if(strcmp(type, "STRING") == 0){
	Tag *elm1 = new TElem(new OStr("env"));
	/* (% env) */

	TLArrow *lar = new TLArrow(t1->Copy(), elm1);
	/* tp.env <- (% env) */

	TBang *ban = new TBang(t2->Copy(), lar);
	/* tp.trans ! (... <- ...) */

	Function *ext = new FExtract(ban);
	/* extract( ... ! (.. <- ..)) */

	Function *nam = new FConst(new OName(s));

	Function *com = new FCompose(ext, nam);
	/* extract (...) o K ( id ) */

	return com;
      }

      if(strcmp(type, "VAR") == 0){
    
	Tag * elm1  = new TElem(new OStr("env"));
	/* (% env)  */
	
	TagExp *lar = new TLArrow(t1->Copy(), elm1);
	/* tp.env <- (% env) */

	TagExp *ban1 = new TBang(t2->Copy(), lar);
	/* tp.trans ! ( ... <- ... ) */
	
	Function *ext1 = new FExtract(ban1);
	/* extract( ...! (...<-...)) */
	
	Function *elt = new FElt();
	
	TagExp *tag1 = new TTilde(new TElem(new OStr("env")));
	TagExp *tag2 = new TTilde(new TElem(new OStr(s)));
	
	TagExp *ban2 = new TBang(tag1, tag2); 

	Function *ext2 = new FExtract(ban2);

	Function *com1 = new FCompose(elt, ext2);
	/* elt o extract(... ! ...) */

	Function *com2 = new FCompose(ext1, com1);
	/* extract(...) o elt o extract(...) */
	
	return com2;
      }
    }
}


TagExp *TpTransTagExp(char *id)
{
  if(id == NULL)
    return NULL;
  else
    {
      TagExp *til = new TTilde(new TElem(new OStr(id)));
      /* ~(% id) */
      
      TagExp *dol = new TDollar(til);
      /* $ ~ (% id) */
      
      return dol;
    }
}


Tag *TpTag(char *id)
{
  Tag* elm  = new TElem(new OStr(id));
  /* (% id)  */
  
  return elm;
}


TagExp *TpTransTagExp(TagExp *t)
{
  if(t == NULL)
    return NULL;
  else
    {
      TagExp *dol = new TDollar(new TQuestion());
      /* $ ? */
 
      Predicate *mat = new PMatch( t->Copy() );
      /* match(...) */

      TagExp * tst= new TSt(dol, mat);
      /* $ ( ? ) st ( match (...)) */
 
      return tst;
    }
}


TagExp *TpTransTagExp( char *id, char *str )
{
  if(id == NULL || str == NULL)
    return NULL;
  else
    {
      TagExp *dol = new TDollar(new TTilde(new TElem(new OStr(id))));
      /* $ ~ (% id ) */
      
      Function *val = new FValue();
      /* value */
      
      Predicate *pcelt = new PCElt(new PEqual(), new OStr(str));
      /* C(equal, str) */
      
      PCombine* pcom = new PCombine(pcelt, val);
      /* C(eq, str) OPLUS value */
      
      TagExp* tst = new TSt(dol, pcom);
      /* ($ ~ (...)) st ( C(...) OPLUS ..) */
      
      return tst;
    }
}


TagExp *TpEnvTagExp ( TagExp *t, char *id, char *s )
{
  if(t == NULL || id == NULL || s == NULL)
    return NULL;
  else
    {
      TagExp *til =  new TTilde(new TElem(new OStr(id)));
      /* ~(% id) */
      
      Tag *elm = new TElem(new OStr(s));
      /* (% s) */

      TagExp *ban = new TBang(t->Copy(), til);
      /* tp.tag ! ~ (% id)*/

      TagExp *lar = new TLArrow(ban, elm);
      /* (... ! ...) <- (% s) */

      return lar;
    }
}


TagExp *TpEnvTagExp ( int no, TagExp *t1, TagExp *t2, Tag *t3, char *v )
{
  if(t1 == NULL || t2 == NULL || t3 == NULL || v == NULL)
    return NULL;
  else
    {
      if(no == 0){
	TagExp *dol = new TDollar(new TTilde(t3->Copy()));
	/* $ ~ ( t3 ) */
	
	TagExp *ban = new TBang(t2->Copy(), dol);
	/* t2 ! $ ~ (t3) */
	
	TagExp *lar = new TLArrow(ban, new TElem(new OStr(v)));
	/* (... !  $ ~ (...)) <-(% v) */

	TagExp *alt = new TAlt(t1->Copy(), lar);

	return alt;
      }
      
      if(no == 1){
	TagExp *til = new TTilde(t3->Copy()); 
	TagExp *ban = new TBang(t2->Copy(), til);
	TagExp *lar = new TLArrow(ban, new TElem(new OStr(v)));
	TAlt *alt = new TAlt(t1->Copy(), lar);
	
	return alt;
      }
    }
}


TagExp *TpTransTagExp(char *id, TagExpList* t)
{
  if(id == NULL || t == NULL)
    return NULL;
  else
    {
      TagExp *til = new TTilde(new TElem(new OStr(id)));
      TagExp *tdb = new TDoubleBang(til, t->Copy());
      return tdb;
    }
}


TagExpList *TpListTransTagExpList(TagExp *t)
{
  if(t == NULL)
    return NULL;
  else
    {
      TagExpList* tpl = new TagExpList();
      tpl->insert(t->Copy());
      return tpl;
    }
}


TagExpList *TpListTransTagExpList(TagExp *t, TagExpList* tl )
{
  if(t == NULL || tl == NULL )
    return NULL;
  else 
    {
      TagExpList *tpl = tl->Copy();
      tpl->insert(t->Copy());
      return tpl;
    }
}


TagExp *TpListEnvTagExp ( TagExp *t1, TagExp *t2 )
{
  if(t1 == NULL || t2 == NULL)
    return NULL;
  else
    {
      TagExp *alt = new TAlt(t1->Copy(), t2->Copy());
      /*t1 \| t2 */
	
      return alt;
    }
}


Function *ConsTransFunc(Function *f)
{
  if( f == NULL)
    return NULL;
  else
    {
      Function *res = f->Copy();
      
      return res;
    }
}
  

Function *ElemTransFunc(char *s)
{
  if( s == NULL)
    return NULL;
  else
    {
      TagExp *til = new TTilde(new TElem(new OStr(s)));
      /* ~ (% s) */
      
      TagExp *env  = new TTilde(new TElem(new OStr("env")));

      TagExp *ban = new TBang(env, til);
      
      Function *ext = new FExtract(ban);

      return ext;
    }
} 


TagExp *TpListPathTagExp(char *id, TagExp *t)
{
  if(id == NULL || t == NULL)
    return NULL;
  else
    {
      TagExp *til = new TTilde(new TElem(new OStr(id)));
      TagExp *ban = new TBang(t->Copy(), til);

      return ban;
    }
}

Function *ElemTransFunc(int no, char *s1, char *s2)
{
  if(s1 == NULL || s2 == NULL)
    return NULL;
  else
    {
      if(no == 0){
	TagExp *env = new TTilde(new TElem(new OStr("env"))); 
	TagExp *til1 = new TTilde(new TElem(new OStr(s1)));
	Tag *elm = new TElem(new OStr(s2));
    
	TagExp *ban = new TBang(env, til1);
	TagExp *lar = new TLArrow(ban, elm);
	
	Function *ext = new FExtract(lar);
	
	return ext;
      }

      /* refine later */
      if(no == 1){
	return NULL;
      }
    }
}


Function *ElemTransFunc(char *s, Function *f)
{
  if(s == NULL || f == NULL)
    return NULL;
  else
    {
      Function *ele = new FEle(new TElem(new OStr(s)));
      
      Function *sin = new FSingleton ();
  
      Function *com1 = new FCompose(ele, f->Copy());
      /* ele o trans */
      
      Function *com2 = new FCompose(sin, com1);
      /* singleton o ele o trans */
  
      return com2;
    }
}


Function *ElemListTransFunc(Function *f1, Function *f2)
{
  if(f1 == NULL || f2 == NULL)
    return NULL;
  else
    {
      Function *par = new FPlus(f1->Copy(), f2->Copy());
      Function *app = new FApp();
      Function *com = new FCompose(app, par);
      return com;
    }
}

Predicate *WhereTransPred(Predicate *p1, Predicate *p2)
{
  if(p1 == NULL || p2 == NULL)
    return NULL;
  else
    {
      Predicate *pcon = new PConjunct(p1->Copy(), p2->Copy());
      return pcon;
    }
}


Predicate *CondTransPred(char *type, Function *f1, Function *f2){
  if(type == NULL || f1 == NULL || f2 == NULL)
    return NULL;
  else
    {
      if(strcmp(type, "EQ") == 0){
	Function *par = new FPlus(f1->Copy(), f2->Copy());
	Predicate *equ = new PEqual();
	Predicate *comb = new PCombine(equ, par);
	return comb;
      }
      
      if(strcmp(type, "NEQ") == 0){
	Function *par = new FPlus(f1->Copy(), f2->Copy());
	Predicate *neq= new PNotEqual();
	Predicate *comb = new PCombine(neq, par);
	return comb;
      }
    }
}

Function *ExpTransFunc(char *type, char *s)
{
  if(type == NULL || s == NULL)
    return NULL;
  else
    {
      if(strcmp(type, "VAR") == 0){
	Function *elt  =new FElt();
	TagExp *til = new TTilde(new TElem(new OStr(s)));
	/* ~ (% s) */

	TagExp *env = new TTilde(new TElem(new OStr("env")));
	/* ~ (% env) */

	TagExp *ban = new TBang(env, til);
	/* ~ (% env) ! ~ (% s) */
	Function *ext = new FExtract(ban);
	
	Function *com  = new FCompose(elt, ext);
	/* elt o extract (... ! ...) */
	
	return com;
      }  
      
      if(strcmp(type, "STRING") == 0 ){
	Function  *sin = new FSingleton();
	Function  *con = new FConst(new OStr(s));
	Function  *com = new FCompose(sin, con);
	return com;
      }
    }
  
}


/*$ ? */

TagExp* TpPathTagExp()
{
  return new TDollar(new TQuestion());
}

/* ? st (K (true)) */

TagExp* TpTEnvTagExp()
{
  Predicate* pcon = new PConst(new BPrimitive(T));
  TagExp* que = new TQuestion();
  TagExp *tst= new TSt(que, pcon);
  return tst;
}

/* ? st (K (false))*/

TagExp* TpFEnvTagExp()
{
  Predicate* pcon = new PConst(new BPrimitive(F));
  TagExp* que = new TQuestion();
  TagExp *tst= new TSt(que, pcon);
  return tst;
}


